routes/web.php
<?php

use App\Http\Controllers\AlbumController;
use App\Http\Controllers\ArtistController;
use App\Http\Controllers\CartController;
use App\Http\Controllers\CustomerController;
use App\Http\Controllers\EmployeeController;
use App\Http\Controllers\IndexController;
use App\Http\Controllers\InvoiceController;
use App\Http\Controllers\PlaylistController;
use App\Http\Controllers\RoleController;
use App\Http\Controllers\TrackController;
use App\Http\Controllers\UserController;
use Illuminate\Support\Facades\Route;

/* Index : show all * Show : show one * Create : show form to create * Store : store new * Edit : show form to edit * Update : update * Destroy : delete */
Route::get('/', [IndexController::class, 'index'])->name('index');

Route::get('/register', [UserController::class, 'create'])->name('register');
Route::get('/login', [UserController::class, 'login'])->name('login');
Route::get('/logout', [UserController::class, 'logout'])->name('logout');

Route::name('users.')->group(function () {
    Route::post('/users/authenticate', [UserController::class, 'authenticate'])->name('authenticate');
    Route::post('/users', [UserController::class, 'store'])->name('store');
    Route::get('/account', [UserController::class, 'accountIndex'])->name('account');
    Route::patch('/users/{user}', [UserController::class, 'update'])->name('update');
});

Route::name('albums.')->group(function () {
    Route::get('/albums', [AlbumController::class, 'index'])->name('index');
    Route::get('/albums/create', [AlbumController::class, 'create'])->name('create');
    Route::post('/albums', [AlbumController::class, 'store'])->name('store');
    Route::get('/albums/export/', [AlbumController::class, 'export'])->name('export');
    Route::post('/albums/{album}/cart', [AlbumController::class, 'addToCart'])->name('cart');
    Route::get('/albums/{album}/export', [AlbumController::class, 'exportOne'])->name('export.one');
    Route::get('/albums/{album}/edit', [AlbumController::class, 'edit'])->name('edit');
    Route::post('/albums/{album}/restore', [AlbumController::class, 'restore'])->name('restore');
    Route::delete('/albums/{album}', [AlbumController::class, 'destroy'])->name('destroy');
    Route::put('/albums/{album}', [AlbumController::class, 'update'])->name('update');
    Route::get('/albums/{album}', [AlbumController::class, 'show'])->name('show');
});

Route::name('tracks.')->group(function () {
    Route::get('/tracks', [TrackController::class, 'index'])->name('index');
    Route::get('/tracks/create', [TrackController::class, 'create'])->name('create');
    Route::get('/tracks/{track}', [TrackController::class, 'edit'])->name('edit');
    Route::put('/tracks/{track}', [TrackController::class, 'update'])->name('update');
    Route::post('/tracks', [TrackController::class, 'store'])->name('store');
    Route::delete('/tracks/{track}', [TrackController::class, 'destroy'])->name('destroy');
    Route::post('/tracks/{track}/restore', [TrackController::class, 'restore'])->name('restore');
});

Route::name('artists.')->group(function () {
    Route::get('/artists', [ArtistController::class, 'index'])->name('index');
    Route::get('/artists/export', [ArtistController::class, 'export'])->name('export');
    Route::get('/artists/create', [ArtistController::class, 'create'])->name('create');
    Route::delete('/artists/{artist}', [ArtistController::class, 'destroy'])->name('destroy');
    Route::get('/artists/{artist}/edit', [ArtistController::class, 'edit'])->name('edit');
    Route::post('/artists/{artist}/restore', [ArtistController::class, 'restore'])->name('restore');
    Route::put('/artists/{artist}', [ArtistController::class, 'update'])->name('update');
    Route::post('/artists', [ArtistController::class, 'store'])->name('store');
});

Route::name('playlists.')->group(function () {
    Route::get('/playlists', [PlayListController::class, 'index'])->name('index');
    Route::get('/playlists/{playlist}/export', [PlaylistController::class, 'export'])->name('export');
    Route::get('/playlists/create', [PlaylistController::class, 'create'])->name('create');
    Route::get('/playlists/{playlist}', [PlayListController::class, 'show'])->name('show');
    Route::get('/playlists/{playlist}/create', [PlaylistController::class, 'createTrack'])->name('tracks.create');
    Route::post('/playlists/{playlist}', [PlayListController::class, 'storeTrack'])->name('tracks.store');
    Route::delete('/playlists/{playlist}', [PlaylistController::class, 'destroy'])->name('destroy');
    Route::delete('/playlists/{playlist}/{track}', [PlayListController::class, 'destroyTrack'])->name('destroy.track');
    Route::post('/playlists', [PlayListController::class, 'store'])->name('store');
});

Route::name('invoices.')->group(function () {
    Route::get('/invoices', [InvoiceController::class, 'index'])->name('index');
    Route::delete('/invoices/{invoice}', [InvoiceController::class, 'destroy'])->name('destroy');
    Route::get('/invoices/{invoice}', [InvoiceController::class, 'show'])->name('show');
});

Route::name('cart.')->group(function () {
    Route::get('/cart', [CartController::class, 'index'])->name('index');
    Route::get('/cart/success', [CartController::class, 'success'])->name('success');
    Route::post('/cart', [CartController::class, 'store'])->name('store');
    Route::post('/cart/create-step-one', [CartController::class, 'createStepOneStore'])->name('create.step.one.store');
    Route::post('/cart/{track}', [CartController::class, 'addToCart'])->name('add');
    Route::delete('/cart/{id}', [CartController::class, 'deleteFromCart'])->name('delete');
    // we could use PUT if route --> /cart/{id}/quantity
    Route::patch('/cart/{id}', [CartController::class, 'update'])->name('update');
});

Route::name('customers.')->group(function () {
    Route::get('/customers', [CustomerController::class, 'index'])->name('index');
    Route::get('/customers/create', [CustomerController::class, 'create'])->name('create');
    Route::delete('/customers/{customer}', [CustomerController::class, 'destroy'])->name('destroy');
    Route::post('/customers', [CustomerController::class, 'store'])->name('store');
    Route::get('/customers/{customer}/edit', [CustomerController::class, 'edit'])->name('edit');
    Route::post('/customers/{customer}/restore', [CustomerController::class, 'restore'])->name('restore');
    Route::put('/customers/{customer}', [CustomerController::class, 'update'])->name('update');
});

Route::name('employees.')->group(function () {
    Route::get('/employees', [EmployeeController::class, 'index'])->name('index');
    Route::get('/employees/create', [EmployeeController::class, 'create'])->name('create');
    Route::delete('/employees/{employee}', [EmployeeController::class, 'destroy'])->name('destroy');
    Route::post('/employees', [EmployeeController::class, 'store'])->name('store');
    Route::get('/employees/{employee}/edit', [EmployeeController::class, 'edit'])->name('edit');
    Route::post('/employees/{employee}/restore', [EmployeeController::class, 'restore'])->name('restore');
    Route::put('/employees/{employee}', [EmployeeController::class, 'update'])->name('update');
    Route::post('/employees/{employee}/account', [EmployeeController::class, 'storeAccount'])->name('store.account');
});

Route::name('roles.')->group(function () {
    Route::get('/roles', [RoleController::class, 'index'])->name('index');
    Route::get('/roles/create', [RoleController::class, 'create'])->name('create');
    Route::post('/roles', [RoleController::class, 'store'])->name('store');
    Route::get('/roles/{role}/edit', [RoleController::class, 'edit'])->name('edit');
    Route::put('/roles/{role}', [RoleController::class, 'update'])->name('update');
    Route::delete('/roles/{role}', [RoleController::class, 'destroy'])->name('destroy');
});

Route::fallback(fn () => abort(404));

app/Models/Album.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;
use Illuminate\Database\Eloquent\Relations\BelongsTo;
use Illuminate\Database\Eloquent\Relations\HasMany;
use Illuminate\Database\Eloquent\SoftDeletes;
use Kyslik\ColumnSortable\Sortable;

class Album extends Model
{
    use HasFactory, SoftDeletes, Sortable;

    protected $sortable = ['title', 'updated_at', 'artist.name'];
    protected $sortableAs = ['tracks_count'];
    protected $fillable = ['title', 'artist_id', 'pochette'];
    protected $with = ['artist'];
    protected $withCount = ['tracks as tracks_count'];

    public function artist(): BelongsTo {
        return $this->belongsTo(Artist::class, 'artist_id')->withTrashed();
    }

    public function tracks(): HasMany {
        return $this->hasMany(Track::class, 'album_id');
    }

    public function invoices() {
        return $this->hasManyThrough(InvoiceItem::class, Track::class);
    }

    public function scopePopular($query, int $total = 5) {
        return $query->withSum('invoices as total_invoices_album', 'quantity')
                     ->orderBy('total_invoices_album', 'desc')
                     ->take($total);
    }

    public function scopeFilter($query, array $filter) {
        if ($filter['search'] ?? false) {
            return $query
                ->where('title', 'like', '%' . request('search') . '%')
                ->orWhereHas('artist', function ($artist) {
                    $artist->where('name', 'like', '%' . request('search') . '%');
                });
        }

        if ($filter['artist'] ?? false)
            return $query->where('artist_id', '=', request('artist'));

        return $query;
    }

    public static function orderedAlbums() {
        return self::orderBy('title', 'asc')->get(['id', 'title']);
    }

    public static function boot() {
        parent::boot();
        static::deleting(fn($album) => $album->tracks()->delete());
        static::restoring(fn($album) => $album->tracks()->restore());
    }
}

app/Models/Track.php
<?php

namespace App\Models;

use Gloudemans\Shoppingcart\Contracts\Buyable;
use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;
use Illuminate\Database\Eloquent\Relations\BelongsTo;
use Illuminate\Database\Eloquent\SoftDeletes;
use Kyslik\ColumnSortable\Sortable;

class Track extends Model implements Buyable
{
    use HasFactory, SoftDeletes, Sortable;

    protected $sortable = ['name', 'milliseconds', 'unit_price', 'genre.name'];
    protected $sortableAs = ['invoice_items_sum_quantity'];
    protected $fillable = ['name', 'album_id', 'media_type_id', 'genre_id', 'composer', 'milliseconds', 'bytes', 'unit_price'];
    protected $with = ['mediaType', 'genre']; // eager loading by default - optimize request !

    public function album(): BelongsTo {
        return $this->belongsTo(Album::class, 'album_id')->withTrashed();
    }

    public function genre() {
        return $this->belongsTo(Genre::class, 'genre_id');
    }

    public function mediaType() {
        return $this->belongsTo(MediaType::class, 'media_type_id');
    }

    public function invoiceItems() {
        return $this->hasMany(InvoiceItem::class, 'track_id');
    }

    public function getArtistAttribute()
    {
        return $this->album?->artist?->name ?? 'Artiste inconnu';
    }

    public function getMinutesAttribute()
    {
        return gmdate('H:i:s', $this->milliseconds/1000);
    }

    public function toSeconds()
    {
        return floor($this->milliseconds/1000);
    }

    public function getBuyableIdentifier($options = null)
    {
        return $this->id;
    }

    public function getBuyableDescription($options = null)
    {
        return $this->name;
    }

    public function getBuyablePrice($options = null)
    {
        return $this->unit_price;
    }

    public function getPopularityAttribute() {
        $popularity = config('popularity');

        foreach ($popularity as $current)
            if ($this->invoice_items_sum_quantity < $current['to'])
                return $current['result'];

        return 'Aucune';
    }

    public function artistSortable($query, $direction) {
        return $query->leftjoin('albums', 'tracks.album_id', '=', 'albums.id')
            ->leftjoin('artists', 'albums.artist_id', '=', 'artists.id')
            ->orderBy('artists.name', $direction);
    }

    public function scopePopular($query, int $total = 5) {
        return $query->withSum('invoiceItems as quantity_sum', 'quantity')->orderBy('quantity_sum', 'desc')->take($total);
    }

    public function scopeFilter($query, array $filter) {
        if ($filter['search'] ?? false) {
            return $query->where('name', 'like', '%' . request('search') . '%')
                ->orWhereHas('genre', fn($genre) => $genre->where('name', 'like', '%' . request('search') . '%'))
                ->orWhereHas('album.artist', fn($artist) => $artist->where('name', 'like', '%' . request('search') . '%'));
        }

        return $query;
    }
}

app/Http/Controllers/AlbumController.php
<?php

namespace App\Http\Controllers;

use App\Exports\AlbumsExport;
use App\Exports\AlbumWithDetailsExport;
use App\Models\Album;
use App\Models\Artist;
use Illuminate\Http\Request;
use Illuminate\Validation\Rule;
use Maatwebsite\Excel\Facades\Excel;

class AlbumController extends Controller
{
    public function __construct(){
        $this->middleware('auth');
        $this->middleware('permission:albums.edit')->only(['edit', 'update']);
        $this->middleware('permission:albums.delete')->only(['destroy', 'restore']);
        $this->middleware('permission:albums.create')->only(['create', 'store']);
    }

    public function index(){
        $datas = auth()->user()->can('albums.delete') ? Album::withTrashed() : Album::withoutTrashed();

        $datas = $datas->sortable()
            ->withCount('tracks as tracks_count')
            ->filter(\request()->input())
            ->orderBy('albums.updated_at', 'desc')
            ->paginate(15);

        return view('albums.index')->with('albums', $datas);
    }

    public function show(Album $album){
        $tracks = auth()->user()->can('albums.delete') ? $album->tracks()->withTrashed() :  $album->tracks()->withoutTrashed();
        $tracks = $tracks->orderBy('id', 'desc')->paginate(15);
        return view('albums.show', ['album' => $album, 'tracks' => $tracks]);
    }

    public function restore($idAlbum){
        $album = Album::onlyTrashed()->findOrFail($idAlbum);
        $album->restore();
        return back()->with('success', 'Album restauré avec succès.');
    }

    public function create(){
        return view('albums.create')
            ->with('artists', Artist::orderBy('name', 'asc')->get(['id', 'name']))
            ->with('album', new Album);
    }

    public function store(Request $request){
        $formFields = $request->validate([
            'artist_id' => ['required', Rule::exists('albums', 'artist_id')],
            'title' => ['required', Rule::unique('albums', 'title')->where(function($query) {
                return $query->where('artist_id', \request('artist_id'));
            })]
        ]);

        if ($request->hasFile('pochette'))
            $formFields['pochette'] = $request->file('pochette')->store('pochettes', 'public');

        Album::create($formFields);

        return back()->with('success', 'Création réussie avec succès !');
    }

    public function edit(Album $album){
        return view('albums.edit')
            ->with('artists', Artist::orderBy('name', 'asc')->get(['id', 'name']))
            ->with('album', $album);
    }

    public function update(Request $request, Album $album){
        $formFields = [];

        if ($request->input('artist_id') != $album->artist_id || $request->input('title') != $album->title) {
            $formFields = $request->validate([
                'artist_id' => ['required', Rule::exists('albums', 'artist_id')],
                'title' => ['required', Rule::unique('albums', 'title')->where(function($query) {
                    return $query->where('artist_id', \request('artist_id'));
                })]
            ]);
        }

        if ($request->hasFile('pochette'))
            $formFields['pochette'] = $request->file('pochette')->store('pochettes', 'public');

        $album->update($formFields);

        return back()->with('success', 'Modification réussie avec succès !');
    }

    public function destroy(Album $album){
        $album->delete();
        return back()->with('success', 'Suppression de l\'album avec succès !');
    }

    public function export(){
        return Excel::download(new AlbumsExport, 'albums.xlsx');
    }

    public function exportOne(Album $album){
        return Excel::download(new AlbumWithDetailsExport($album), 'album_'.$album->title.'.xlsx');
    }

    public function addToCart(Album $album){
        $tracks = $album->tracks;
        foreach ($tracks as $track)
            \Gloudemans\Shoppingcart\Facades\Cart::add($track, 1,  ['artiste' => $track->artist]);
        return back()->with('success', 'Ajout au panier avec succès !');
    }
}

resources/views/albums/create.blade.php
<x-layout>
    {{ Breadcrumbs::render() }}

    <x-title>
        <x-slot name="pageHeading">
            Création d'un <span class="text-blue-600">album</span>
        </x-slot>
        <a href="{{ route('albums.index') }}" class="cursor-pointer w-full px-4 py-2 text-sm text-white font-medium bg-blue-500 hover:bg-blue-600 border border-blue-600 rounded-md shadow-button">
            Retour aux albums
        </a>
    </x-title>

    <div class="flex max-w-lg mx-auto flex-col mt-10">
        <div class="p-8 bg-white rounded shadow">
            <div class=" text-center">
                <span class="text-sm text-blueGray-400 content-center">Albums</span>
                <h4 class="mb-6 text-3xl">Créer un album</h4>
            </div>
            <form method="POST" action="{{ route('albums.store') }}" role="form" enctype="multipart/form-data">
                @csrf
                @include('albums.form')
            </form>
        </div>
    </div>
</x-layout>

resources/views/albums/edit.blade.php
<x-layout>
    {{ Breadcrumbs::render() }}

    <x-title>
        <x-slot name="pageHeading">
            Modification d'un <span class="text-blue-600">album</span>
        </x-slot>
        <a href="{{ route('albums.index') }}" class="cursor-pointer w-full px-4 py-2 text-sm text-white font-medium bg-blue-500 hover:bg-blue-600 border border-blue-600 rounded-md shadow-button">
            Retour
        </a>
    </x-title>

    <div class="flex max-w-lg mx-auto flex-col mt-10">
        <div class="p-8 bg-white rounded shadow">
            <div class=" text-center">
                <span class="text-sm text-blueGray-400 content-center">Albums</span>
                <h4 class="mb-6 text-3xl">Modifier un album</h4>
            </div>
            <form method="POST" action="{{ route('albums.update', $album->id) }}" role="form" enctype="multipart/form-data">
                @method('PUT')
                @csrf
                @include('albums.form')
            </form>
        </div>
    </div>
</x-layout>

resources/views/albums/form.blade.php
<input value="{{$album->title ?? old('title')}}" class="appearance-none w-full p-4 text-xs font-semibold leading-none bg-blueGray-50 rounded outline-none @error('title') border-2 border-red-500 @enderror" type="text" name="title" placeholder="Tire de l'album" required>
@error('title')<p class="text-red-500 text-xs italic">{{$message}}</p>@enderror

<select class="mt-4 appearance-none w-full p-4 text-xs font-semibold leading-none bg-blueGray-50 rounded outline-none" name="artist_id" required>
    <option value="0">--Sélectionner l'artiste --</option>
    @foreach($artists as $artist)
        <option value="{{$artist->id}}" {{$album->artist?->id == $artist->id ? 'selected' : ''}}>{{$artist->name}}</option>
    @endforeach
</select>
@error('artist')<p class="text-red-500 text-xs">{{$message}}</p>@enderror

<span class="font-medium block mt-4">Pochette:</span>
<input class="appearance-none w-full p-4 text-xs font-semibold leading-none bg-blueGray-50 rounded outline-none" type="file" name="pochette">

<button class="mt-4 block w-full p-4 text-center text-xs text-white font-semibold leading-none bg-blue-600 hover:bg-blue-700 rounded">Valider les informations</button>

resources/views/albums/index.blade.php
<x-layout>
    {{ Breadcrumbs::render() }}

    <x-search title="des albums" searchBy="Cherchez par le titre des albums ou le nom des artistes !" />

    <x-title>
        <x-slot name="pageHeading">
            Liste des <span class="text-blue-600">albums</span>
        </x-slot>
        <a href="{{ route('albums.export') }}" class="cursor-pointer px-4 py-2 text-sm text-white font-medium bg-blue-500 hover:bg-blue-600 border border-blue-600 rounded-md shadow-button">
            Exporter <i class="ml-2 fa fa-file-excel-o" aria-hidden="true"></i>
        </a>
        @can('albums.create')
        <a href="{{ route('albums.create') }}" class="ml-2 cursor-pointer px-4 py-2 text-sm text-white font-medium bg-green-500 hover:bg-green-600 border border-green-600 rounded-md shadow-button">
            Ajouter
        </a>
        @endcan
    </x-title>

    <div class="relative overflow-x-auto shadow-md sm:rounded-lg mt-10">
        <table class="w-full text-sm text-left text-gray-500">
            <thead class="text-xs text-gray-700 uppercase bg-gray-50">
            <tr>
                <th scope="col" class="px-6 py-3">
                    @sortablelink('title', 'Titre de l\'album')
                </th>
                <th scope="col" class="px-6 py-3">
                    @sortablelink('artist.name', 'Artiste')
                </th>
                <th scope="col" class="px-6 py-3">
                    @sortablelink('tracks_count', 'Chansons')
                </th>
                <th scope="col" class="px-6 py-3">
                    @sortablelink('updated_at', 'Modification')
                </th>
                <th scope="col" class="px-6 py-3">
                    <span class="sr-only">Actions</span>
                </th>
            </tr>
            </thead>
            <tbody>
            @foreach($albums as $album)
            <tr class="bg-white border-b">
                <th scope="row" class="px-6 py-4 font-medium text-gray-900 dark:text-white whitespace-nowrap flex">
                    <img class="w-12 rounded-full hidden lg:flex" alt="pochette" src="{{$album->pochette ? asset('/storage/'.$album->pochette) : asset('/images/no-image.png')}}">
                    <div class="pl-4">
                        <p class="font-semibold">{{$album->title}}</p>
                        <a class="text-blueGray-400" href="{{ route('artists.index', ['search' => $album->artist?->name]) }}">{{$album->artist?->name ?? 'Artiste inconnu'}}</a>
                    </div>
                </th>
                <td class="px-6 py-4">
                    {{$album->artist?->name}}
                </td>
                <td class="px-6 py-4">
                    {{$album->tracks_count}}
                </td>
                <td class="px-6 py-4">
                    {{$album->updated_at}}
                </td>
                <td class="px-6 py-4">
                    <div class="flex justify-end">
                        @unless($album->trashed())
                            @can('cart')
                                <form action="{{route('albums.cart', $album)}}" method="POST">
                                    @csrf <button type="submit" class="border hover:bg-gray-50 font-semibold py-1 px-2 rounded">🛒</button>
                                </form>
                            @endcan
                            <a class="ml-1 border hover:bg-gray-50 font-semibold py-1 px-2 rounded" href="{{route('albums.show', $album->id)}}">🔎</a>
                            @can('albums.edit')
                                <a class="ml-1 border hover:bg-gray-50 font-semibold py-1 px-2 rounded" href="{{route('albums.edit', $album->id)}}">✏</a>
                            @endcan
                            @can('albums.delete')
                                <form action="{{route('albums.destroy', $album->id)}}" method="POST">
                                    @csrf @method('DELETE') <button type="submit" class="ml-1 border hover:bg-gray-50 font-semibold py-1 px-2 rounded">❌</button>
                                </form>
                            @endcan
                        @else
                            <form action="{{ route('albums.restore', $album->id) }}" method="POST">
                                @csrf <button type="submit" class="border hover:bg-gray-50 font-semibold py-1 px-2 rounded">🔓</button>
                            </form>
                        @endunless
                    </div>
                </td>
            </tr>
            @endforeach
            </tbody>
        </table>
    </div>

    @if($albums->hasPages())
        <div class="mt-10">
            {!! $albums->appends(\Request::except('page'))->render() !!}
        </div>
    @endif
</x-layout>

resources/views/albums/show.blade.php
<x-layout>
    {{ Breadcrumbs::render() }}

    <x-title>
        <x-slot name="pageHeading">
            Album <span class="text-blue-600">{{$album->title}}</span>
        </x-slot>
        <a href="{{ route('albums.export.one', $album->id) }}" class="cursor-pointer px-4 py-2 text-sm text-white font-medium bg-blue-500 hover:bg-blue-600 border border-blue-600 rounded-md shadow-button">
            Exporter <i class="ml-2 fa fa-file-excel-o" aria-hidden="true"></i>
        </a>
        @can('tracks.create')
            <a href="{{ route('tracks.create', ['album' => $album]) }}" class="ml-2 cursor-pointer w-full px-4 py-2 text-sm text-white font-medium bg-green-500 hover:bg-green-600 border border-green-600 rounded-md shadow-button">
                Ajouter
            </a>
        @endcan
    </x-title>

    <div class="relative overflow-x-auto shadow-md sm:rounded-lg mt-10">
        <table class="w-full text-sm text-left text-gray-500 dark:text-gray-400">
            <thead class="text-xs text-gray-700 uppercase bg-gray-50 dark:bg-gray-700 dark:text-gray-400">
            <tr>
                <th scope="col" class="px-6 py-3">Titre</th>
                <th scope="col" class="px-6 py-3">Genre</th>
                <th scope="col" class="px-6 py-3">Durée</th>
                <th scope="col" class="px-6 py-3">Type média</th>
                <th scope="col" class="px-6 py-3">Prix</th>
                @canany(['cart', 'albums.edit', 'albums.delete'])
                    <th scope="col" class="px-6 py-3"><span class="sr-only">Actions</span></th>
                @endcan
            </tr>
            </thead>
            <tbody>
            @foreach($tracks as $track)
            <tr class="bg-white border-b">
                <th scope="row" class="px-6 py-4 font-medium text-gray-900 dark:text-white whitespace-nowrap">{{$track->name}}</th>
                <td class="px-6 py-4">{{$track->genre->name}}</td>
                <td class="px-6 py-4">{{$track->minutes}}</td>
                <td class="px-6 py-4">{{$track->mediaType->name}}</td>
                <td class="px-6 py-4">{{$track->unit_price}}Є</td>
                @canany(['cart', 'albums.edit', 'albums.delete'])
                    <td class="px-6 py-4">
                        <div class="flex justify-end">
                            @unless($track->trashed())
                                @can('cart')
                                    <form action="{{route('cart.add', $track)}}" method="POST">
                                        @csrf <button type="submit" class="border hover:bg-gray-50 font-semibold py-1 px-2 rounded ml-1">🛒</button>
                                    </form>
                                @endcan
                                @can('albums.edit')
                                    <a class="border hover:bg-gray-50 font-semibold py-1 px-2 rounded ml-1" href="{{route('tracks.edit', $track)}}">✏</a>
                                @endcan
                                @can('albums.delete')
                                    <form action="{{route('tracks.destroy', $track)}}" method="POST">
                                        @csrf @method('DELETE')
                                        <button type="submit" class="border hover:bg-gray-50 font-semibold py-1 px-2 rounded ml-1">❌</button>
                                    </form>
                                @endcan
                            @else
                                <form action="{{ route('tracks.restore', $track) }}" method="POST">
                                    @csrf
                                    <button type="submit" class="border hover:bg-gray-50 font-semibold py-1 px-2 rounded">🔓</button>
                                </form>
                            @endunless
                        </div>
                    </td>
                @endcan
            </tr>
            @endforeach
            </tbody>
        </table>
    </div>

    @if ($tracks->hasPages())
        <div class="mt-10">
            {{$tracks->links()}}
        </div>
    @endif
</x-layout>